#!/usr/local/bin/python

#
#	Copyright 2005 Larry Barber and the US Dept. of Agriculture.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#

import sys
import re

__all__=['ConfigFile']

class ConfigFile:
	def __init__(self, config_file_name, separator=':'):
		self.cf_name=config_file_name
		self.cf=open(self.cf_name)
		self.config_params = {}
		for in_line in self.cf:
			if in_line[0] == '#':
				continue
			re.sub('^\S', '', in_line)
			re.sub('\S$', '', in_line)
			if len(in_line) == 0:
				continue
			matches = re.match( '(.*)'+separator+'(.*)', in_line)
			if matches == None:
				continue
			param_name = matches.group(1)
			param_val = matches.group(2)
			param_name = re.sub('^\s*', '', param_name)
			param_name = re.sub('\s*$', '', param_name)
			param_val = re.sub('^\s*', '', param_val)
			param_val = re.sub('\s*$', '', param_val)
			self.config_params[param_name] = param_val

	def getVal(self, key, default=None):
		if key in self.config_params.keys():
			return str(self.config_params[key])
		else: 
			print 'Not found: ' + key
			return default

	def getKeys(self ):
		return self.config_params.keys()
			
		
if __name__ == '__main__':
	c_file = ConfigFile('test_config_file', separator=':')

	cf_keys = c_file.getKeys()
	print cf_keys

	for key in cf_keys:
		print c_file.getVal(key)

